# -*- coding: utf-8 -*-

class MovieParser:

	def __init__(self):
		pass
		
	def setParams(self, html, canali):
		self.html = html
		self.canali = canali
	
	def trovaFilm(self):
		blocchi = self.trovaBlocchi()
		self.movies = []
		
		for entry in blocchi:
			film = {}
			film['titolo'] = self.trovaTitolo(entry)
			film['orario'] = self.trovaOrario(entry)
			film['valutazione'] = self.trovaValutazione(entry)
			film['genere'] = self.trovaGenere(entry)
			self.movies.append(film)
		
		self.trovaCanali()
	
	def bloccoHTML(self, stringa, inizio, fine, lista = False):
		start = stringa.find(inizio)
		result = []
		
		while (start > 0):
			end = stringa.find(fine, start)
			result.append(stringa[start +len(inizio) :end])
			start = stringa.find(inizio, end)
		
		if (len(result) == 1 and lista == False):
			return result.pop()
		
		if (len(result) == 0):
			return '';
		return result
	
	def trovaBlocchi(self):
		return self.bloccoHTML(self.html, '(212, 249, 211);">', '</tr>', True)
	
	def trovaTitolo(self, html):		
		return self.bloccoHTML(html, '<b>', '</b>')
		
	def trovaOrario(self, html):
		return self.bloccoHTML(html, '<td style="width:5%;">', '</td>')
		
	def trovaValutazione(self, html):
		return self.bloccoHTML(html, 'pubblico: ', ' stelle').pop()
	
	def trovaGenere(self, html):
		return  self.bloccoHTML(html, ' - ', '\r\n              </div>')
		
	def trovaCanali(self):
		movies = []
		
		for film in self.movies:
			for canale, wanted in self.canali.items():				
				if (not wanted): continue
				if (self.bloccoHTML(self.html, \
				'Film e serie TV su %s' % canale,\
				'programmazione Tv completa di %s' % canale).find(film['titolo']) > 0):
					film['canale'] = canale
					movies.append(film)
		
		self.movies = movies
				
	def filmTrovati(self):
		return len(self.movies)
		
	def listaFilm(self):
		self.trovaFilm()
		return self.movies
